# SAS 9 Deployment

## Overview
Data Controller consists of a frontend app, a set of Stored Processes and a database library.  The library can be a SAS Base engine if desired, however this can cause contention (eg table locks) if end users are able to connect to the datasets directly, eg via Enterprise Guide or Base SAS.
A database that supports concurrent access is recommended.

## Backend

1 - Import `/sas/import.spk` using SAS Management Console.  Make a note of the root location in which this was deployed - as this will be added to the `appLoc` value in the `index.html` file in the [frontend](#frontend) deployment.

2 - Create a physical staging directory.  This folder will contain the logs and CSV files generated by Users.  The SAS Spawned Server account (eg `sassrv`) will need write access to this location.

3 - Update the library to point to a schema in your preferred database

4 - Deploy the physical tables and register them in metadata.  For this, simply compile and run the `mpe_build()` macro using an  account with appropriate privileges.

!!! note
    Make sure the SAS Spawned Server account (eg `sassrv`) can access these tables!

## Frontend
The Data Controller front end comes pre-built, and ready to deploy to the root of the SAS Web Server (mid-tier), typically `!SASCONFIG/LevX/Web/WebServer/htdocs` in SAS 9.

Deploy as follows:

1 - Unzip dcfrontend.zip and upload the entire `datacontroller` directory to the static content server.

2 - Open the `index.html` file and update the `appLoc` value to the location where the Stored Processes were deployed earlier. 

It should now be possible to use the application - simply navigate to `YOURSASWEBLOC.domain/yourRoot/datacontroller` and sign in!

The next step is to [configure](dcc-tables.md) the tables.


